diff --git a/libr/core/cmd_anal.c b/libr/core/cmd_anal.c
index 4b7e8306f51..fca4891bf54 100644
--- a/libr/core/cmd_anal.c
+++ b/libr/core/cmd_anal.c
@@ -196,15 +196,25 @@ static const char *help_detail_ae[] = {
 };
 
 static const char *help_msg_aea[] = {
-	"Examples:", "aea", " show regs used in a range",
-	"aea", " [ops]", "Show regs used in N instructions (all,read,{no,}written,memreads,memwrites)",
+	"Examples:", "aea", " show regs and memory accesses used in a range",
+	"aea", "  [ops]", "Show regs/memory accesses used in N instructions ",
 	"aea*", " [ops]", "Create mem.* flags for memory accesses",
 	"aeaf", "", "Show regs used in current function",
 	"aear", " [ops]", "Show regs read in N instructions",
 	"aeaw", " [ops]", "Show regs written in N instructions",
 	"aean", " [ops]", "Show regs not written in N instructions",
 	"aeaj", " [ops]", "Show aea output in JSON format",
-	"aeA", " [len]", "Show regs used in N bytes (subcommands are the same)",
+	"aeA", "  [len]", "Show regs used in N bytes (subcommands are the same)",
+	"Legend:", "", "for ae{a,f,A}",
+	"I", "", "input registers (read before being set)",
+	"A", "", "all regs accessed",
+	"R", "", "register values read",
+	"W", "", "registers written",
+	"NW", "", "= NW= not written",
+	"@R", "", "memreads",
+	"@W", "", "memwrites",
+	"NOTE:", "", "mem{reads,writes} with PIC only fetch the offset",
+
 	NULL
 };
 
@@ -4221,11 +4231,24 @@ static void showregs (RList *list) {
 	r_cons_newline();
 }
 
+static void showmem (RList *list) {
+	if (!r_list_empty (list)) {
+		AeaMemItem *item;
+		RListIter *iter;
+		r_list_foreach (list, iter, item) {
+			r_cons_printf (" 0x%08"PFMT64x, item->addr);
+			
+		}
+	}
+	r_cons_newline();
+}
+
 static void showregs_json (RList *list) {
 	r_cons_printf ("[");
 	if (!r_list_empty (list)) {
 		char *reg;
 		RListIter *iter;
+
 		r_list_foreach (list, iter, reg) {
 			r_cons_printf ("\"%s\"", reg);
 			if (iter->n) {
@@ -4236,6 +4259,21 @@ static void showregs_json (RList *list) {
 	r_cons_printf ("]");
 }
 
+static void showmem_json (RList *list) {
+	r_cons_printf ("[");
+	if (!r_list_empty (list)) {
+		RListIter *iter;
+		AeaMemItem *item;
+		r_list_foreach (list, iter, item) {
+			r_cons_printf ("\"0x%08"PFMT64x"\"", item->addr);
+			if (iter->n) {
+				r_cons_printf (",");
+			}
+		}
+	}
+	r_cons_printf ("]");
+}
+
 static bool cmd_aea(RCore* core, int mode, ut64 addr, int length) {
 	RAnalEsil *esil;
 	int ptr, ops, ops_end = 0, len, buf_sz, maxopsize;
@@ -4363,6 +4401,11 @@ static bool cmd_aea(RCore* core, int mode, ut64 addr, int length) {
 		showregs_json (stats.regwrite);
 		r_cons_printf (",\"N\":");
 		showregs_json (regnow);
+		r_cons_printf (",\"@R\":");
+		showmem_json(mymemxsr);
+		r_cons_printf (",\"@W\":");
+		showmem_json(mymemxsw);
+		
 		r_cons_printf ("}");
 		r_cons_newline();
 	} else if ((mode >> 5) & 1) {
@@ -4382,22 +4425,26 @@ static bool cmd_aea(RCore* core, int mode, ut64 addr, int length) {
 		} else {
 			r_cons_newline();
 		}
-		RListIter *iter;
-		ut64 *n;
-		if (!r_list_empty (mymemxsr)) {
-			r_cons_printf ("@R:");
-			r_list_foreach (mymemxsr, iter, n) {
-				r_cons_printf (" 0x%08"PFMT64x, *n);
-			}
-			r_cons_newline ();
-		}
-		if (!r_list_empty (mymemxsw)) {
-			r_cons_printf ("@W:");
-			r_list_foreach (mymemxsw, iter, n) {
-				r_cons_printf (" 0x%08"PFMT64x, *n);
-			}
-			r_cons_newline ();
-		}
+		r_cons_printf ("@R:");
+		showmem(mymemxsr);
+		r_cons_printf ("@W:");
+		showmem(mymemxsw);
+		// RListIter *iter;
+		// AeaMemItem *n;
+		// if (!r_list_empty (mymemxsr)) {
+		// 	r_cons_printf ("@R:");
+		// 	r_list_foreach (mymemxsr, iter, n) {
+		// 		r_cons_printf (" 0x%08"PFMT64x, n->addr);
+		// 	}
+		// 	r_cons_newline ();
+		// }
+		// if (!r_list_empty (mymemxsw)) {
+		// 	r_cons_printf ("@W:");
+		// 	r_list_foreach (mymemxsw, iter, n) {
+		// 		r_cons_printf (" 0x%08"PFMT64x, n->addr);
+		// 	}
+		// 	r_cons_newline ();
+		// }
 	}
 	r_list_free (mymemxsr);
 	r_list_free (mymemxsw);
